<?php

defined('_JEXEC') or die('Acesso restrito ao Joomla!');
jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
include_once(JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_mymural" . DS . "includes" . DS . "functions.class.php");
require_once(JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_mymural" . DS . "includes" . DS . "wideimage_lib" . DS . "WideImage.inc.php");

class MymuralController extends JController {

    function  __construct($default = array()) {

        parent::__construct($default);

        $this->registerTask('add', 'edit'); //$this->registerTast('task enviada', 'function chamada pela task');
        $this->registerTask('apply', 'save');
        $this->registerTask('unpublish', 'publish');

        $this->registerTask('sobre_mymural', 'sobreMymural');
		$this->registerTask('texto_introducao', 'textoIntroducao');
		$this->registerTask('salva_texto_introducao', 'salvaTextoIntroducao');

        //Administração das Áreas
        $this->registerTask('admin_areas', 'adminAreas');
        $this->registerTask('adicionar_area', 'adicionaArea');
        $this->registerTask('editar_area', 'editaArea');
        $this->registerTask('remover_area', 'removeArea');
        $this->registerTask('publicar_area', 'publicaArea');
    }

    function edit() {

        global $option;
        $row =& JTable::getInstance('mymural', 'Table'); //Obtém o vínculo com a tabela #__mymural
        $cid = JRequest::getVar('cid', array(0), '', 'array'); //Extrai o ID do registro selecionado, que depois é carregado como $row->load($id);
        $id = $cid[0];

        // Obtem os dados cadastrados do recado selecionado na lista de recados
        if($id != 0) {
            $row->load($id);
        }
        else {
            $row->id = JRequest::getVar('id', '', 'post', 'string', JREQUEST_ALLOWRAW);
            $row->area = JRequest::getVar('area', '', 'post', 'string', JREQUEST_ALLOWRAW);
            $row->nome = JRequest::getVar('nome', '', 'post', 'string', JREQUEST_ALLOWRAW);
            $row->profissao = JRequest::getVar('profissao', '', 'post', 'string', JREQUEST_ALLOWRAW);
            $row->email = JRequest::getVar('email', '', 'post', 'string', JREQUEST_ALLOWRAW);
            $row->cidade_uf = JRequest::getVar('cidade_uf', '', 'post', 'string', JREQUEST_ALLOWRAW);
            $row->mensagem = JRequest::getVar('mensagem', '', 'post', 'string', JREQUEST_ALLOWRAW);
        }
        HTML_mymural::editaRecado($row, $option); //Apresenta o formulário para editar o recado

    }

    function save() {

        global $option, $mainframe;

        JRequest::checkToken() or die ('Token Inválido'); //Aqui gera um tipo de chave de segurança, que se não for a mesma gerada pelo Framework, há suspeita de invasão e a ação é cancelada.
        $row =& JTable::getInstance('mymural', 'Table'); //Cria uma instancia da classe TableMymural, obtendo o vínculo com a tabela mymural

        if(!$row->bind(JRequest::get('post'))) { //liga o array dos elementos gerados por POST  aos atributos da classe TableMymural
            echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
            exit();
        }

        $id =  JRequest::getVar('id', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $area =  JRequest::getVar('area', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $nome =  JRequest::getVar('nome', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $profissao =  JRequest::getVar('profissao', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $email = JRequest::getVar('email', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $cidade_uf = JRequest::getVar('cidade_uf', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $mensagem = nl2br(JRequest::getVar('mensagem', '', 'post', 'string', JREQUEST_ALLOWRAW));

        //Manipulação da Imagem
        $imagem = JRequest::getVar('imagem', null, 'files', 'array');

        if($imagem['name'] != null) {

            if($id != null) {
                $db =& JFactory::getDBO();
                $query = "SELECT imagem FROM #__mymural WHERE id = " . $id;
                $db->setQuery($query);
                $db->query($query);
                $resultado = $db->loadResult();

                $imagemAntiga = strtolower(end(explode('/', $resultado)));

                @unlink(JPATH_ROOT.DS."images".DS."mymural".DS.$imagemAntiga);
            }

            $cod_imagem = rand(1111111111, time());
            $extensao = JFile::makeSafe(strtolower(end(explode('.', $imagem['name']))));

            $nomeImagem = "mymural_" . $cod_imagem . "." . $extensao;

            $src = $imagem['tmp_name'];
            $dirDestino = JPATH_ROOT.DS."images".DS."mymural".DS. $nomeImagem;

            //Aqui usa os métodos da LIB WideImage, pra redimensionar e salvar a imagem no tamanho correto
            /*
             * resize(largura, altura, tipo de redimensionamento "proporcional, se preenche tudo, etc", direção "só redimensiona se for maior, sempre redimensiona, etc...")
            */
            if(!wiImage::load($imagem['tmp_name'])->resize(120,120,'inside', 'down')->saveToFile($dirDestino)) {
                $row->imagem = "images/mymural/" . $nomeImagem;
            }
            else {
                $msg = "Erro ao fazer o upload da imagem.<br />";
            }
            /*if(JFile::upload($src, $dirDestino))
                $row->imagem = "images/mymural/" . $nomeImagem;
            else
                $msg = "Erro ao fazer o upload da imagem.<br />";*/
        }

        //Fim da manipulação da imagem

        $row->area = $area;
        $row->nome = $nome;
        $row->profissao = $profissao;
        $row->email = $email;
        $row->cidade_uf = $cidade_uf;
        $row->mensagem = $mensagem;
        $row->id = (int) $row->id;
		$row->published = '1';

        // Valida se é um novo registro ou não... se for, atualiza o campo data_cadastro com a data atual, se não, deixa como está.
        if($id == null) {
            $dataAtual = date('Y-m-d H:i:s');
            $row->data_cadastro = $dataAtual;
        }

        $erro = false;

        if(trim($area) == "" || $area == null || $area == '0') {
            $erro = true;
            $msg = JText::_('Atenção: O campo AREA deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        }

        if(trim($nome) == "" || $nome == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo NOME deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        }

        if(trim($profissao) == "" || $profissao == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo PROFISSÃO deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        }

        if(trim($email) == "" || $email == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo E-MAIL deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        }

        if(!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email)) {
            $erro = true;
            $msg = JText::_('Atenção: E-MAIL inválido!');
            $mainframe->enqueueMessage($msg, 'error');
        }


        if(trim($cidade_uf) == "" || $cidade_uf == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo CIDADE/UF deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        }

        if(trim($mensagem) == "" || $mensagem == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo PROFISSÃO deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        }

        //Fim das validações no formulário

        if(!$row->store()) { //Executa a gravação dos atributos recuperados na tabela #__mymural
            echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
            exit();
        }
        //Este switch valida se foi acionado o botão aplicar ou Salvar, para montar a URL corretamente.
        switch($this->_task) {
            case 'apply':
                $msg .= 'Alterações efetuadas com sucesso!';
                //$msg .= "Imagem: " . $dirDestino;
                $link = 'index.php?option=' . $option . '&task=edit&cid[]=' . $row->id;
                break;
            case 'save':
            default:
                $msg .= 'Registro gravado com sucesso!';
                $link = 'index.php?option=' . $option;
                break;
        }

        $this->setRedirect($link, $msg); //Direciona o fluxo para a URL montada no switch

    } //save()


    function remove() {

        global $option;
        $cid = JRequest::getVar('cid', array(), '', 'array'); //$cid recebe um array com uma lista de ids selecionados para remoção.
        $db =& JFactory::getDBO();
        if(count($cid)) {
            JArrayHelper::toInteger($cid); //Converte todos elementos do array em inteiro, pra não ter erro...
            $cids = implode(',', $cid); //Converte todos elementos do array em uma string com os IDs separados por vírgula, daí fica tipo: DELETE FROM #__mymural WHERE id IN (2,5,7); hehe

            //Este bloco armazena no array $imgs todas as imagens dos registros selecionados, e caso consiga efetuar a query, deleta as imagens dos mesmos...
            $db =& JFactory::getDBO();
            $imgs = array();
            for($i = 0; $i<count($cid); $i++) {
                $query = "SELECT imagem FROM #__mymural WHERE id = " . $cid[$i];
                $db->setQuery($query);
                $db->query($query);
                $resultado = $db->loadResult();
                $imgs[$i] = strtolower(end(explode('/', $resultado)));
            }
            //Até aqui capturou do BD o nome de todas as imagens.

            $query = "DELETE FROM #__mymural WHERE id IN ($cids)";
            $db->setQuery($query);
            if(!$db->query()) {
                echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
                exit();
            }
            //Se a query for executada corretamente, deleta as imagens do diretório...
            else {
                foreach($imgs as $img) {
                    @unlink(JPATH_ROOT.DS."images".DS."mymural".DS.$img);
                }
            }
        }
        $this->setRedirect('index.php?option=' . $option);

    }//remove()

    function publish() {

        global $option;
        $cid = Jrequest::getVar('cid', array(), '', 'array'); //$cid recebe um array com uma lista de ids selecionados para remoção.
        if($this->_task == 'publish') { //_task conterá o valor 'publish'... (se foi acionado o botão Publicar ou Despublicar)... daí faz a validação pra atribuir o valor correto
            $publish = 1;
        }
        else {
            $publish = 0;
        }

        $MymuralTable =& JTable::getInstance('mymural', 'Table');
        $MymuralTable->publish($cid, $publish); //atualiza o estado dos parâmetros publish em todos itens selecionados,
        $this->setRedirect('index.php?option=' . $option);

    }//publish()

    function mostraRecados() {

        global $option, $mainframe;

        //aqui é o esquema pra exibição dos arquivos com paginação... hehe
        $limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit')); //Pega a número de elementos por pagina q foi definido no arquivo configuration.php
        $limitstart = JRequest::getVar('limitstart', 0); //Obtém o valor inicial da lista apresentada
        $db =& JFactory::getDBO();

        //Agora obtém a qtde de registros
        $query = "SELECT count(*) FROM #__mymural";
        $db->setQuery($query);
        $total = $db->loadResult(); //Armazena o total de registros na variável $total

        $query = "SELECT * FROM #__mymural ORDER BY data_cadastro DESC";
        $db->setQuery($query, $limitstart, $limit);
        $rows = $db->loadObjectList();

        if($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }

        jimport('joomla.html.pagination');
        $pageNav = new JPagination($total, $limitstart, $limit);
        HTML_mymural::mostraRecados($option, $rows, $pageNav);

    }//mostraRecados()

    function adminAreas() {

        global $option, $mainframe;

        $db =& JFactory::getDBO();
        $query = "SELECT * FROM #__mymural_areas ORDER BY id ASC";
        $db->setQuery($query, $limitstart, $limit);
        $rows = $db->loadObjectList();

        HTML_mymural::adminAreas($option, $rows);
    }

    function adicionaArea() {

        global $option;
        $nomeArea = JRequest::getVar('nome_area');

        $db =& JFactory::getDBO();
        $query = "INSERT INTO #__mymural_areas VALUES(0, '$nomeArea', 1, now())";
        $db->setQuery($query);

        if(!$db->query()) {
            echo "<script> alert('Houve um erro ao atualizar o status do Registro. \nTente novamente.'); window.history.go(-1);</script>\n";
            exit();
        }

        $this->setRedirect('index.php?option=' . $option . '&task=admin_areas');

    }

    function editaArea() {

        global $option;
        $idArea = JRequest::getVar('id_area_edit');
        $nomeArea = JRequest::getVar('novo_nome_area_edit');

        $db =& JFactory::getDBO();
        $query = "UPDATE #__mymural_areas SET nome = '$nomeArea' WHERE id = $idArea";
        $db->setQuery($query);

        if(!$db->query()) {
            echo "<script> alert('Houve um erro ao atualizar o status do Registro. \nTente novamente.'); window.history.go(-1);</script>\n";
            exit();
        }

        $this->setRedirect('index.php?option=' . $option . '&task=admin_areas');

    }

    function publicaArea() {

        global $option;
        $idArea = JRequest::getVar('id');
        $publish = JRequest::getVar('acao');

        if($publish == '1')
            $acao = '1';
        else
            $acao = '0';

        $db =& JFactory::getDBO();
        $query = "UPDATE #__mymural_areas SET published = $acao WHERE id = $idArea";
        $db->setQuery($query);
        if(!$db->query()) {
            echo "<script> alert('Houve um erro ao atualizar o status do Registro. \nTente novamente.'); window.history.go(-1);</script>\n";
            exit();
        }

        $this->setRedirect('index.php?option=' . $option . '&task=admin_areas');
    }

    function removeArea() {

        global $option;
        $idArea = JRequest::getVar('id');

        $db =& JFactory::getDBO();

        $query = "SELECT * FROM #__mymural WHERE area = $idArea";
        $db->setQuery($query);
        $db->query();
        $totalRecados = $db->loadResult();

        if($totalRecados > 0){
            $msg = 'Existem recados armazenados nesta Área. Exclua estes recados e tenta novamente!';
            $this->setRedirect('index.php?option=' . $option . '&task=admin_areas', $msg);
        }
        else
        {
            $query = "DELETE FROM #__mymural_areas WHERE id = $idArea";
            $db->setQuery($query);

            if(!$db->query()) {
                echo "<script> alert('Houve um erro ao atualizar o status do Registro. \nTente novamente.'); window.history.go(-1);</script>\n";
                exit();
            }
            $msg = 'Área excluída com sucesso!';
            $this->setRedirect('index.php?option=' . $option . '&task=admin_areas', $msg);
        }
    }


    function sobreMymural(){

        global $option;

        HTML_mymural::sobreMymural($option);
    }
	
	function textoIntroducao(){

        global $option;
		$db =& JFactory::getDBO();
		
		$query = "SELECT params FROM #__components WHERE admin_menu_link = 'option=com_mymural&task=texto_introducao'";
        $db->setQuery($query);
        $texto = $db->loadResult();

        if($db->getErrorNum()) {
            echo $db->stderr();
            return false;
        }

        HTML_mymural::textoIntroducao($option, $texto);
    }
	
	function salvaTextoIntroducao() {

        global $option, $mainframe;

        $textoIntroducao =  JRequest::getVar('texto_introducao', '', 'post', 'string', JREQUEST_ALLOWRAW);

        $db =& JFactory::getDBO();
        $query = "UPDATE #__components SET params = '$textoIntroducao' WHERE admin_menu_link = 'option=com_mymural&task=texto_introducao'";
        $db->setQuery($query);

        if(!$db->query()) {
            $msg = 'Houve um erro ao salvar o texto de introdução. Tente novamente!';
        }
		else{
			$msg = 'Texto salvo com sucesso!';
		}
		
        $this->setRedirect('index.php?option=' . $option . '&task=texto_introducao', $msg);	
		
	}

}


?>